"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createController = void 0;
var tslib_1 = require("tslib");
var Controller_1 = tslib_1.__importDefault(require("./Controller"));
var lodash_1 = require("lodash");
function createController(initialState, create, dispose) {
    var MergingController = /** @class */ (function (_super) {
        tslib_1.__extends(MergingController, _super);
        function MergingController() {
            var _this = _super.call(this, initialState) || this;
            _this.controller = create(function () { return _this.state; }, _this.emit.bind(_this));
            return _this;
        }
        MergingController.prototype.dispose = function () {
            return tslib_1.__awaiter(this, void 0, void 0, function () {
                return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.dispose.call(this)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, (dispose === null || dispose === void 0 ? void 0 : dispose())];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return MergingController;
    }(Controller_1.default));
    var merging = new MergingController();
    var result = (0, lodash_1.merge)(merging, merging.controller);
    return result;
}
exports.createController = createController;
//# sourceMappingURL=createController.js.map