"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelector = void 0;
var useBuilder_1 = require("./useBuilder");
function useSelector(context, stateSelector) {
    var buildWhen = function (prev, curr) { return stateSelector(prev) !== stateSelector(curr); };
    var _a = (0, useBuilder_1.useBuilder)(context, buildWhen), state = _a[0], controller = _a[1];
    return [stateSelector(state), controller];
}
exports.useSelector = useSelector;
//# sourceMappingURL=useSelector.js.map