import React from 'react';
import { CElement, DOMElement, DetailedReactHTMLElement, FunctionComponentElement, PropsWithChildren, ReactElement, ReactHTMLElement, ReactSVGElement } from 'react';
type ReceivableElement = DetailedReactHTMLElement<any, any> | ReactHTMLElement<any> | ReactSVGElement | DOMElement<any, any> | FunctionComponentElement<any> | CElement<any, any> | ReactElement<any>;
type NestedProps = {
    elements: ReceivableElement[];
};
declare const Nested: React.FC<PropsWithChildren<NestedProps>>;
export type { ReceivableElement, NestedProps };
export default Nested;
