import React from 'react';
var Nested = function (_a) {
    var elements = _a.elements, children = _a.children;
    var renderNested = function (nestedElements, nestedChildren) {
        var currentElement = nestedElements[0], remainingElement = nestedElements.slice(1);
        if (currentElement) {
            return React.cloneElement(currentElement, undefined, renderNested(remainingElement, nestedChildren));
        }
        return children;
    };
    return renderNested(elements, children);
};
export default Nested;
//# sourceMappingURL=Nested.js.map