import { __awaiter, __extends, __generator } from "tslib";
import Controller from './Controller';
import { merge } from 'lodash';
function createController(initialState, create, dispose) {
    var MergingController = /** @class */ (function (_super) {
        __extends(MergingController, _super);
        function MergingController() {
            var _this = _super.call(this, initialState) || this;
            _this.controller = create(function () { return _this.state; }, _this.emit.bind(_this));
            return _this;
        }
        MergingController.prototype.dispose = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, _super.prototype.dispose.call(this)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, (dispose === null || dispose === void 0 ? void 0 : dispose())];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return MergingController;
    }(Controller));
    var merging = new MergingController();
    var result = merge(merging, merging.controller);
    return result;
}
export { createController };
//# sourceMappingURL=createController.js.map