import { useState } from 'react';
import { useController } from './useController';
import { useListener } from './useListener';
function useBuilder(context, buildWhen) {
    if (buildWhen === void 0) { buildWhen = function () { return true; }; }
    var controller = useController(context);
    var _a = useState(function () { return controller.state; }), state = _a[0], setState = _a[1];
    useListener(context, function (newState) { return setState(newState); }, function (prev, curr) { return buildWhen(prev, curr); });
    return [state, controller];
}
export { useBuilder };
//# sourceMappingURL=useBuilder.js.map