"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Nested = function (_a) {
    var elements = _a.elements, children = _a.children;
    var renderNested = function (nestedElements, nestedChildren) {
        var currentElement = nestedElements[0], remainingElement = nestedElements.slice(1);
        if (currentElement) {
            return react_1.default.cloneElement(currentElement, undefined, renderNested(remainingElement, nestedChildren));
        }
        return children;
    };
    return renderNested(elements, children);
};
exports.default = Nested;
//# sourceMappingURL=Nested.js.map