"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBuilder = void 0;
var react_1 = require("react");
var useController_1 = require("./useController");
var useListener_1 = require("./useListener");
function useBuilder(context, buildWhen) {
    if (buildWhen === void 0) { buildWhen = function () { return true; }; }
    var controller = (0, useController_1.useController)(context);
    var _a = (0, react_1.useState)(function () { return controller.state; }), state = _a[0], setState = _a[1];
    (0, useListener_1.useListener)(context, function (newState) { return setState(newState); }, function (prev, curr) { return buildWhen(prev, curr); });
    return [state, controller];
}
exports.useBuilder = useBuilder;
//# sourceMappingURL=useBuilder.js.map