import { useContext } from 'react';
import { ControllerNotProvided } from './error';
function useController(context) {
    var controller = useContext(context._context);
    if (controller === undefined) {
        throw new ControllerNotProvided("The requested controller is not provided in scope, make sure you have wrap it's Provider");
    }
    return controller;
}
export { useController };
//# sourceMappingURL=useController.js.map