import { useBuilder } from './useBuilder';
function useSelector(context, stateSelector) {
    var buildWhen = function (prev, curr) { return stateSelector(prev) !== stateSelector(curr); };
    var _a = useBuilder(context, buildWhen), state = _a[0], controller = _a[1];
    return [stateSelector(state), controller];
}
export { useSelector };
//# sourceMappingURL=useSelector.js.map